//*****************************************
// 	Zv iOtBbNkbcgpj Program ATMega328
// CPU Clock:1MHz
//   iq[Yf[^@WāAUWlgɂj
//
//
//	File name: rtc_ake6.c
//
//  v֌W
//   sQgAɊւĂ timer.c ɋLq
//
//  2017/05/30 New(TAB4)  Taishi
//  2017/06/26  Modify ohb̃vOC by Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"pr_ake6_glcd.h"
#include	"glcd.h"
#include	"timer.h"
#include	"switch.h"
#include	"ake6.h"
#include	"utility.h"
#include	"disp_ake6.h"
#include	"rtc_ake6.h"

unsigned char 	gUcd[11];
signed char		bityousei[24];			// OOQR܂ł̔li|X`{Xje̖ɒl߂KvL
signed char		bityousei_sum;			// l̃T

const signed char		bityousei_org[24] = {		// ddoqnlĂ̂OOQR܂ł̔li|X`{Xje̖ɒl߂KvL
//  0   1   2   3   4   5   6   7   8   9  10  12
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,

// 13  14  15  16  17  18  19  20  21  22  23  24
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	};
unsigned char	eep_bityousei_sum[8] EEMEM = {0};													// l̃T
unsigned char	eep_bityousei[24] EEMEM = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};		// l


//***************************
// v
//  XCb`̒ZŎ̍ڂֈړ
//  XCb`̒ŒlŏI
//  EXCb`̉Œl{P
//***************************
void	adjust_time(void)
{
	unsigned short	us;
	unsigned char	adj = 1;
	unsigned char	ten = 0;						// OF\͉ȂAPF\AQF\
	unsigned char	henkou = 0;
	unsigned char	set_sec;						// b vl
	unsigned char	set_min;						//  vl
	unsigned char	set_hou;						//  vl
	unsigned char	set_day;						//  vl
	unsigned char	set_mon;						//  vl
	unsigned char	set_yer;						// N vl
	unsigned char	d_limit;

	led_on();										// LED ON

	wait_sw_off();									// XCb`nee҂

	set_sec = gRTC_sec;								// b vl
	set_min = gRTC_min;								//  vl
	set_hou = gRTC_hou;								//  vl
	set_day = gRTC_day;								//  vl
	set_mon = gRTC_mon;								//  vl
	set_yer = gRTC_yer;								// N vl

	tim_1s_escape = 20;								// ݒ胂[h甲ׂ̂PrPʃ^C}[
	while(1){
		us = get_action_sw();									// XCb`Ԃ
		if((us & SW2_ON) != 0){									// EXCb`Ă鎞
			ten = 0;
			tim_1s_escape = 20;									// ݒ胂[h甲ׂ̂PrPʃ^C}[
		}else if(tim_10ms_blink == 0){
			if(ten == 1){
				ten = 2;
			}else{
				ten = 1;
			}
			tim_10ms_blink = 25;
		}

		if((us & SW1_OFF_LONG) != 0){							// XCb`ėꂽ
			if(henkou == 1){									// ύXĂ
				if((set_yer % 4) == 0){							// 邤N
					d_limit = gMon_ls_uru[set_mon];
				}else{
					d_limit = gMon_ls[set_mon];
				}
				if(31 < d_limit){
					d_limit = 31;
				}
				if(d_limit < set_day){
					set_day = d_limit;
				}
				gRTC_sec = set_sec;									// b vl
				gRTC_min = set_min;									//  vl
				gRTC_hou = set_hou;									//  vl
				gRTC_day = set_day;									//  vl
				gRTC_mon = set_mon;									//  vl
				gRTC_yer = set_yer;									// N vl
			}
			disp_ymdhms();											// Nb\
			break;													// ̊֐甲
		}else if((us & SW1_OFF_SHORT) != 0){						// XCb`Zėꂽ
			switch(adj){
			 case 1:												// N̎
				disp_yer(set_yer);	// N̕\
				break;
			 case 2:												// ̎
				disp_mon(set_mon);	// ̕\
				break;
			 case 3:												// ̎
				disp_day(set_day);	// ̕\
				break;
			 case 4:												// ̎
				disp_hou(set_hou);	// ̕\
				break;
			 case 5:												// ̎
				disp_min(set_min);	// ̕\
				break;
			 case 6:												// b̎
				disp_sec(set_sec);	// b̕\
				break;
			}
			adj++;													// 
			if(6 < adj){
				adj = 1;
			}
			ten = 1;
			tim_10ms_blink = 0;
		}else if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// EXCb`ꂽ
			henkou = 1;
			switch(adj){
			 case 1:												// N̎
				set_yer++;											// N{P
				if(99 < set_yer){
					set_yer = 0;
				}
				break;
			 case 2:												// ̎
				set_mon++;											// {P
				if(12 < set_mon){
					set_mon = 1;
				}
				break;
			 case 3:												// ̎
				set_day++;											// {P
				if((set_yer % 4) == 0){								// 邤N
					d_limit = gMon_ls_uru[set_mon];
				}else{
					d_limit = gMon_ls[set_mon];
				}
				if(31 < d_limit){
					d_limit = 31;
				}
				if(d_limit < set_day){
					set_day = 1;
				}
				break;
			 case 4:												// ̎
				set_hou++;											// {P
				if(23 < set_hou){
					set_hou = 0;
				}
				break;
			 case 5:												// ̎
				set_min++;											// {P
				if(59 < set_min){
					set_min = 0;
				}
				break;
			 case 6:												// b̎
				set_sec++;											// b{P
				if(59 < set_sec){
					set_sec = 0;
				}
				break;
			}
			ten = 1;
			tim_10ms_blink = 25;
		}

		// ̐̓_
		if(ten == 1){												// _ł̓_ɂȂ
			switch(adj){
			 case 1:												// N
				disp_yer(set_yer);	// N̕\
				break;
			 case 2:												// 
				disp_mon(set_mon);	// ̕\
				break;
			 case 3:												// ̎
				disp_day(set_day);	// ̕\
				break;
			 case 4:												// ̎
				disp_hou(set_hou);	// ̕\
				break;
			 case 5:												// ̎
				disp_min(set_min);	// ̕\
				break;
			 case 6:												// b̎
				disp_sec(set_sec);	// b̕\
				break;
			 default:
				break;
			}
		}else if(ten == 2){											// _ł̖łɂȂ
			disp_moji[0] = ' ';
			disp_moji[1] = ' ';
			disp_moji[2] = 0x00;
			switch(adj){
			 case 1:												// N
				disp_yer(0xff);										// N̕\
				break;
			 case 2:												// 
				disp_mon(0xff);										// ̕\
				break;
			 case 3:												// 
				disp_day(0xff);										// ̕\
				break;
			 case 4:												// 
				disp_hou(0xff);										// ̕\
				break;
			 case 5:												// 
				disp_min(0xff);										// ̕\
				break;
			 case 6:												// b̎
				disp_sec(0xff);										// b̕\
				break;
			}
		}

		if (tim_1s_escape == 0){									// ݒ胂[h甲ׂ̃^C}[I
			break;
		}
	}

	wait_sw_off();													// XCb`nee҂

	led_off();														// LED OFF

}

//***************************
// l̃T߂
//***************************
static
signed char	get_bityou_sum(void)
{
	unsigned char	uc;
	signed char		s;

	for(s = 0,uc = 0; uc < 24; uc++){
		s += bityousei[uc];
	}

	return(s);
}
//***************************
// l
//   ɔlƃT
//***************************
static
void	wtite_bityousei(void)
{
	unsigned char	uc;

	for(uc = 0; uc < 24; uc++){
		eeprom_busy_wait();
		eeprom_write_byte(&eep_bityousei[uc], bityousei[uc]);		// 
	}
	eeprom_busy_wait();
	eeprom_write_byte(&eep_bityousei_sum[0], bityousei_sum);		// 
}
//***************************
// lǂݏo
//   Ă鎞͏lɂ
//***************************
void	read_bityousei(void)
{
	unsigned char	uc;
	unsigned char	s;											// lT

	for(uc = 0; uc < 24; uc++){
		eeprom_busy_wait();
		bityousei[uc] = eeprom_read_byte(&eep_bityousei[uc]);	// Ǐo
	}

	bityousei_sum = eeprom_read_byte(&eep_bityousei_sum[0]);	// OOQR܂ł̔T Ǐo
	s = get_bityou_sum();										// l̃TvZŋ߂
	if (s != bityousei_sum){									// Ⴄ
		for(uc = 0; uc < 24; uc++){
			bityousei[uc] = bityousei_org[uc];					// OOQR܂ł̔l
		}
		bityousei_sum = get_bityou_sum();						// l̃TvZŋ߂
		wtite_bityousei();										// l
		set_trim = 1;											// lC
	}
}
//***************************************
// P̔l\
//   l̉ԖځiO`QRj
//***************************************
static
void	disp_bityo(unsigned char uc)
{
	signed char	sc;

	sc = bityousei[uc];					// l

	gUcd[2] = 0x00;
	gUcd[0] = (uc / 10)+'0';
	gUcd[1] = (uc % 10)+'0';
	disp_lcd_G_15x24(0, 1, gUcd);		// ԍ\

	if(sc == 0){						// lO
		gUcd[0] = ' ';
		gUcd[1] = '0';
	}else if(0 < sc){					// lvX
		gUcd[0] = '+';
		gUcd[1] = (sc % 10)+'0';
	}else{								// l}CiX
		gUcd[0] = '-';
		gUcd[1] = ((0-sc) % 10)+'0';
	}
	disp_lcd_G_15x24(4, 1, gUcd);		// l\

}
//***************************************
// l̏C
//***************************************
void	adjust_bityo(void)
{
	unsigned short			us = 0;
	unsigned char			ud = 0;

	led_on();													// LED ON

	disp_clear_lcd_G();
	disp_lcd_G_10x16(0, 0, (unsigned char *)("RTC TRIM"));
	wait_sw_off();												// XCb`nee҂

	disp_bityo(ud);												// P̔l\
	disp_lcd_G_15x24(2, 1,(unsigned char *)("H="));				//  l̏ČŒ蕔\

	while(1){
		us = get_action_sw();									//@XCb`Ԃ

		if((us & SWS_OFF_LONG) != 0){							// XCb`ėꂽ
			bityousei_sum = get_bityou_sum();					// l̃TvZŋ߂
			cli();												//	荞݋֎~
			wtite_bityousei();									// l
			sei();												// SĂ̊݉
			break;												// ̊֐甲
		}else if((us & SW1_OFF_SHORT) != 0){					// XCb`Zėꂽ
			ud++;												// ̔l
			if(24 <= ud){
				ud = 0;
			}
			disp_bityo(ud);										// P̔l\
		}else if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_OFF_SHORT) != 0)){	// EXCb`ꂽ
			bityousei[ud]++;									// l{P
			if(9 < bityousei[ud]){
				bityousei[ud] = -9;
			}
			disp_bityo(ud);										// P̔l\
		}
	}

	led_off();													// LED OFF

}

//***************************
// RTC PԖ̔
//  vf[^͈ȉ̕ϐɓĂ镨Ƃ(-9 <--> +9)
//	unsigned char	gRTC_sec;		// qsb b̃f[^ (0--59)
//	unsigned char	gRTC_min;		// qsb ̃f[^ (0--59)
//	unsigned char	gRTC_hou;		// qsb ̃f[^ (0--23j
//	PbԂɂPĂ΂
//  OQQOb̎ɔ
// ߂l@OFȂA@OȊOFi}CiXf[^͌ݎ߂AvXf[^͌ݎi߂j
//***************************
signed char	rtc_adjust_hour(void)
{
	signed char		r=0;
	signed char		byo;
	static	unsigned char	adj_pass = 0;

	if((gRTC_min == 2)&&(gRTC_sec == 20)){				// OQQOb̎
		if(adj_pass != 0){								// ēxł̏hׁA󂪗L͎
			adj_pass = 0;								// ɂ
		}else{
			r = bityousei[gRTC_hou];					// OOQR܂ł̔li|X`{Xj
			if(r != 0){									// 鎞
				byo = (signed char)gRTC_sec;			// vZׂ̈ɓǂݏo
				byo += r;								// 
				gRTC_sec = (unsigned char)byo;			// vZʂ߂
				if(r < 0){								// v߂̂łOQROb܂̂
					adj_pass = 1;						//  ɒt
				}
			}
		}
	}
	return(r);
}
