//***************************************************************************************
// 	Zv iOtBbNkbcgpj Program ATMega328
// CPU Clock:1MHz
//   iq[Yf[^@WāAUWlgɂj
//
//	File name: switch.c
//
//  2017/05/30 New(TAB4)  Taishi
//***************************************************************************************

#include	<avr/io.h>

#include	"pr_ake6_glcd.h"
#include	 "switch.h"


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++ XCb`
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

unsigned char			gTim_10ms_sw;				// XCb`pPOrPʃ^C}[
unsigned char			gTim_10ms_sw2_length;		// EXCb`pԂPOrPʃ^C}[
unsigned char			gTim_10ms_sw2_continue;		// EXCb`pAPOrPʃ^C}[
unsigned char			gTim_10ms_sw1_length;		// XCb`pԂPOrPʃ^C}[
unsigned char			gTim_10ms_sw1_continue;		// XCb`pAPOrPʃ^C}[
unsigned char			gTim_10ms_sws_length;		// ʃXCb`pԂPOrPʃ^C}[
unsigned char			gTim_10ms_sws_continue;		// ʃXCb`pAPOrPʃ^C}[
unsigned char			sw[4];						// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
static	unsigned char	old_sw;

//***************************************************************************************
//	SW PORT(PC) ݒ
//  vAbv͊O̒Rōs
//***************************************************************************************
void sw_init(void)
{
	DDRC &= ~((1 << DDC1) | (1 << DDC2) | (1 << DDC3));	// Port-C Bit1,2,3 : Input
	old_sw = 0;
}

//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
// SW[3] ɗꂽuԂ'1'̏
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(gTim_10ms_sw == 0){
		gTim_10ms_sw = 3;								// QOrԊu
		uc = ((~PINC) & (SW1_ON_BIT | SW2_ON_BIT | SW3_ON_BIT));		// ]ăXCb`f[^擾
		if (old_sw == uc){								// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);			// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);			// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;									// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}
#define			TMR_LONG			100			// 10mSx200=2Sec ̎Ԗ͒ZԂƂ
#define			TMR_CONTIMUE_FIRST	200			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
#define			TMR_CONTIMUE		50			// 10mSx20=200mS ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
// SW[3] ɗꂽuԂ'1'̏
//***************************
unsigned short	get_action_sw(void)
{
	unsigned short	us=0;

	get_sw();											// XCb`Ԃ

// EXCb`
	if((sw[2] & SW2_ON_BIT) != 0){						// EXCb`nm̏uԂ̎
		us |= (SW2_ON_NOW | SW2_ON);
		gTim_10ms_sw2_continue = TMR_CONTIMUE_FIRST;
		gTim_10ms_sw2_length = TMR_LONG;
	}else if((sw[1] & SW2_ON_BIT) != 0){				// XCb`nm̎
		us |= SW2_ON;
		if(gTim_10ms_sw2_continue == 0){				// ꑱo^C~O̎
			us |= SW2_ON_CONTINUE;
			gTim_10ms_sw2_continue = TMR_CONTIMUE;
		}
	}else if((sw[3] & SW2_ON_BIT) != 0){				// EXCb`ꂽuԂ̎
		if(gTim_10ms_sw2_length == 0){					// ꂽԂ
			us |= SW2_OFF_LONG;
		}else{											// ꂽԂZ
			us |= SW2_OFF_SHORT;
		}
		gTim_10ms_sw2_continue = 0;
		gTim_10ms_sw2_length = 0;
	}else if((sw[1] & SW2_ON_BIT) == 0){				// EXCb`nee̎
		gTim_10ms_sw2_continue = 0;
		gTim_10ms_sw2_length = 0;
	}


// XCb`
	if((sw[2] & SW1_ON_BIT) != 0){						// XCb`nm̏uԂ̎
		us |= (SW1_ON_NOW | SW1_ON);
		gTim_10ms_sw1_continue = TMR_CONTIMUE_FIRST;
		gTim_10ms_sw1_length = TMR_LONG;
	}else if((sw[1] & SW1_ON_BIT) != 0){				// XCb`nm̎
		us |= SW1_ON;
		if(gTim_10ms_sw1_continue == 0){				// ꑱo^C~O̎
			us |= SW1_ON_CONTINUE;
			gTim_10ms_sw1_continue = TMR_CONTIMUE;
		}
	}else if((sw[3] & SW1_ON_BIT) != 0){				// XCb`ꂽuԂ̎
		if(gTim_10ms_sw1_length == 0){					// ꂽԂ
			us |= SW1_OFF_LONG;
		}else{											// ꂽԂZ
			us |= SW1_OFF_SHORT;
		}
		gTim_10ms_sw1_continue = 0;
		gTim_10ms_sw1_length = 0;
	}else if((sw[1] & SW1_ON_BIT) == 0){				// XCb`nee̎
		gTim_10ms_sw1_continue = 0;
		gTim_10ms_sw1_length = 0;
	}

// ʃXCb`
	if((sw[2] & SW3_ON_BIT) != 0){						// ʃXCb`nm̏uԂ̎
		us |= (SWS_ON_NOW | SWS_ON);
		gTim_10ms_sws_continue = TMR_CONTIMUE_FIRST;
		gTim_10ms_sws_length = TMR_LONG;
	}else if((sw[1] & SW3_ON_BIT) != 0){				// ʃXCb`nm̎
		us |= SWS_ON;
		if(gTim_10ms_sws_continue == 0){				// ꑱo^C~O̎
			us |= SWS_ON_CONTINUE;
			gTim_10ms_sws_continue = TMR_CONTIMUE;
		}
	}else if((sw[3] & SW3_ON_BIT) != 0){				// ʃXCb`ꂽuԂ̎
		if(gTim_10ms_sws_length == 0){					// ꂽԂ
			us |= SWS_OFF_LONG;
		}else{											// ꂽԂZ
			us |= SWS_OFF_SHORT;
		}
		gTim_10ms_sws_continue = 0;
		gTim_10ms_sws_length = 0;
	}else if((sw[1] & SW3_ON_BIT) == 0){				// ʃXCb`nee̎
		gTim_10ms_sws_continue = 0;
		gTim_10ms_sws_length = 0;
	}

	return(us);
}

//*****************************************
// XCb`@܂ŉiv[v
//  XCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//*****************************************
void	wait_sw_off(void)
{
	while(1){
		if(((~PINC) & (SW1_ON_BIT | SW2_ON_BIT | SW3_ON_BIT)) == 0){;		// PxڃXCb`f[^nee
			delay_ms(100);													// 100mS Delay
			if(((~PINC) & (SW1_ON_BIT | SW2_ON_BIT | SW3_ON_BIT)) == 0){;	// QxڃXCb`f[^nee
				break;														// {ɗꂽƂ
			}
		}
	}
}
